<?php

namespace Modules\User\Repositories\Contracts;

use Illuminate\Database\Eloquent\Collection;
use Modules\User\Entities\Bank;

interface BankRepositoryInterface
{
    public function getAllPaginated(int $perPage = 10, string $search = '');

    public function getAllWithRelationsPaginated(
        int $perPage = 10,
        string $search = '',
        string $sortBy = 'name',
        string $sortOrder = 'asc'
    );

    public function getAllWithRelations(string $search = ''): Collection;

    public function create(array $data): Bank;

    public function findById(string $id): ?Bank;

    // public function delete(string $id): bool;

    public function all(string $search = ''): Collection;

    public function active(): Collection;
}
